{-----------------------------------------------------------------------------}
{ Global constants, types and variables.		   (c) 1989, 1990 YGP }

  const MaxIncl   =	4;		   { Maximum nesting of include files }
	MaxDef	  =    77;     { Maximum size of area for conditional symbols }
        TxtBuffSz = (*)  111 {*)  1111 {*};           { Size of Source buffer }
	MaxCodeSz = (*) 1280 {*) 10240 {*};   { Max proc size (at least 1024) }
        ShowNameSz= (*)   15 {*)    63 {*};        { Maximum size of filename }

	{ constants for identifier flags }
	_interfaced = $01;  { ProcId, FuncId        }

	_nochange   = $02;  { VarId, FieldId     const  }

	_byaddr     = $04;  { VarId,	          var  }

	_packed     = $04;  { FieldId,			      packed fields }

	_formal     = $02;  { ProcId, FuncId			 { formal p/f }
	_standard   = $04;				       { standard p/f }
	_forward    = $08;			  { forward declared function }
	_overlay    = $10;				  { overlay procedure }
	_external   = $20;				{ external proc/funcs }
	_inline     = $40;				  { inline proc/funcs }
	_hasvalue   = $80;  { FuncId only	 {    return value }

  type alpha  = packed array [0..7] of char;

       symbol =(ident,	    i_const,  r_const,	  c_const,

		{ Class C keywords }
		comma,	    colon,    semicolon,  lpar,      rpar,
		lbra,	    rbra,     arrow_sy,   period,    dbl_period,
		plus_sy,    minus_sy, asterisk,   slash,     eq_sy,
		neq_sy,     les_sy,   leq_sy,	  grt_sy,    geq_sy,
		becomes,    andJWsy,  orJWsy,	  Scomment,  Dcomment,

		{ Class A keywords }
		and_sy,     array_sy, begin_sy,   case_sy,   const_sy,
		div_sy,     do_sy,    downto_sy,  else_sy,   end_sy,
		file_sy,    for_sy,   func_sy,	  goto_sy,   if_sy,
		implmnt_sy, inn_sy,   intface_sy, label_sy,  mod_sy,
		nil_sy,     not_sy,   of_sy,	  or_sy,     packed_sy,
		proc_sy,    prog_sy,  record_sy,  repeat_sy, segmnt_sy,
		set_sy,     then_sy,  to_sy,	  type_sy,   unit_sy,
		until_sy,   uses_sy,  var_sy,	  while_sy,  with_sy,
		xor_sy,

		elsif_sy,		 { when Modula like compilation is ON }

		{ Symbols that are not recognized by insy }
		extrn_sy,   frwrd_sy, code_sy,	  neg_sy,    other_sy);

       Forms = (Scalar, 		 { All numerical types (exept real) 0 }
		Enumerated,				 { Enumerated types 1 }
		SubRange,				   { SubRange types 2 }
		ESubRange,		      { SubRange of enumerated type 3 }
		Reals,				     { Floating point reals 4 }
		Unrslvd,	   { Unresolved forward referenced pointers 5 }
		Pointers,				    { Pointer types 6 }
		PowerSet,					{ Set types 7 }
		Arrays, 				{ Non packed arrays 8 }
		PArrays,				    { Packed arrays 9 }
		Strings,					  { strings a }
		Records,			       { Non packed records b }
		PRecords,				   { Packed records c }
		Files,						    { Files d }
		UnTyped);			  { Untyped var/const parms e }

       {Identifier}Classes = (TypeId,				  { all types }
			      VarId,		     { variables & parameters }
			      ConstId,		   { identifier of a constant }
			      ECnstId,	   { const ident from enumerated type }
			      FieldId,	       { identifier of a record field }
			      LabelId,			  { label identifiers }
			      ProcId,		       { procedure identifier }
			      FuncId,			{ function identifier }
			      UnitId,			    { unit identifier }
			      UnUnitId);	  { unvisible unit identifier }

       LevelKinds = (PFlvl,			  { Procedure/Functions level }
		     rec,			  { record during declaration }
		     Crec,			     { CONST parameter record }
		     Vrec,			       { VAR parameter record }
		     Drec,			     { record (direct access) }
		     Xrec,				    { external record }
		     XCrec,			  { external read only record }
		     UnitLvl);			      { Unit level descriptor }

       DeclKind = (Standrd,  Declared, Forwrd, Intrface,
		   InLinePF, Overlay,  Extrnl, Undecl);

       Parts{of Variant} = (TagField, Variant);

       ImportType = (Unvisible, Visible, InterfacePart);

       VAccess = (direct,	   { direct access (via lex level and offset) }
		  xternal,	    { external access (via seg no and offset) }
		  indirect,	     { indirect access (via address (pointer) }
		  UBaccess,	{ Unsigned Byte access (via extended pointer) }
		  SBaccess);	  { Signed Byte access (via extended pointer) }

       AttrKind = (Cnst, Vrbl, Expr);

       StdProcs = (StdRead,   StdReadLn,  StdWrite, StdWrtLn,
		   StdEof,    StdEoln,
		   StdReset,  StdRewrite, StdOpen,  StdAppend,
		   StdClose,  StdBread,   StdBwrite,
		   StdSeek,   StdFpos,	  StdFsize, StdTrunc,

		   StdOdd,    StdIncl,	  StdExcl,
		   StdInc,    StdDec,	  StdMin,   StdMax,
		   StdOrd,    StdPred,	  StdSucc,
		   StdRnd,    StdRndmz,
		   StdFillC,  StdFillW,   StdMove,  StdMoveW,
		   StdSizeOf, StdWordSz,  StdAbs,   StdSqr,

		   StdRtrn,   StdExit,	  StdHalt,

		   StdAddr,   StdNew,	  StdDispose);

       IdSet = set of {Identifier}Classes;

       syset = set of symbol;

       ByteSet = set of byte;

       ba = packed array [0..1000] of byte;	    {     }

       bap     = ^ba;
       idp     = ^identifier;
       labp    = ^LabelRecord;
       typep   = ^TypeRecord;
       levelp  = ^LevelRecord;
       varntp  = ^VariantPart;
       StringP = ^string;

       Value = record case byte of
	 1: (i: LongInt);
	 2: (r: Real);
	 3: (COffs:   integer;			{ Offset of constant in Cpool }
	     CSegNo:  integer;		       { Segment Number of a constant }
	     case integer of			   { const in compiler memory }
	       1: (SetPtr: ^ByteSet);
	       2: (StrPtr: StringP));
       end { Value };

       identifier = packed record
	 IdType:  typep;				  { Identifier's type }
	 next:	  idp;						   {  }
	 link:	  idp;	    { idents are linked in a sequance (not in a tree) }
	 IdName:  alpha;				 { Name of identifier }
	 IdFlags: byte; 	     { Identifier flags (see _xxx constants ) }
	 case IdClass: {Identifier}Classes of

	   LabelId: (LabOffset: integer);

	   ConstId: (IdValue: Value);

	   ECnstId: (No: natural);	      { constant from enumerated type }

	   TypeId:  (case {InterfaceType: } boolean of
		       true: (TypeNo: Integer));

	   VarId:   (IdAddr: natural);		    { address of a local cell }


	   FieldId: (IdOffset: natural; 	{ Offset in record (in words) }
		     case boolean of			       { if is packed }
		       true: (StartByte, ByteSize: natural)
		    );


	   ProcId,
	   FuncId:  (case DeclKind of
		       Standrd:  (StdPF: StdProcs);	 { Standard Proc/Func }
		       InLinePF: (InLineSz: natural;
				  InLineCode: bap);
		       Extrnl,
		       Overlay,
		       Intrface,
		       Declared: (pf: packed record
				    seg, num: ShortCard;
				    psize: natural;
				  end { pf }; );
		    );
           UnUnitId,
           UnitId:  (Intface: levelp);
       end { identifier };

       TypeRecord = record
	 TSize:  integer;				 { Type Size in words }
	 case TForm: {Type}Forms of

	   Enumerated: (LastConst: idp);

	   ESubRange,
	   SubRange:   (RangeType: typep; tmin, tmax: word);

	   Pointers:   (PointedTp: typep);
	   Unrslvd:    (NextUnrslvd: typep);

	   PowerSet:   (BaseType: typep);

	   PArrays,
	   Arrays:     (IndexType, AElemType: typep;
			case boolean of
			  true: (AByteLng: natural)
		       );

	   Strings:    (StrSize: ShortCard);

	   PRecords,
	   Records:    (FrstId: idp; VarPart: varntp;
			case boolean of
			  true: (RByteLng: natural)
		       );

	   Files:      (FileType: typep;
			RecBytes: integer);   { No of bytes, 0 for non packed }
       end { TypeRecord };

       VariantPart = record	      {  bug   packed record }
	 Vsize: natural;			     {      }
			      { when TagId => Vsize is the min length of type }
	 case Parts{of Variant} of
	   TagField: (TagId:	idp;  LastVpart:	   varntp);
	   Variant:  (VarValue: word; NextVpart, SubVpart: varntp);
       end { VariantPart };

       LabelRecord = record
	 LabNo:    natural;				   {    }
	 NextLab:  labp;			{   user  }
	 offset:   integer;	     {  >= 0 -> offset    proc }
				     {  <  0 -> offset    }
       end { LabelRecord };				 {  = $8000 unused }

       LevelRecord = record
	 Idents:    idp;	  {       }
	 PrevLevel: levelp;				    {   }
	 case LvlKind: LevelKinds of		     {     }
				    { ------- Level  proc/func ------- }
	   PFlvl:   (Files:    idp;	    { All declared files in this proc }
		     Labels:   labp;	 { All user declared labels (numbers) }
		     LabelIds: idp;	  { All user declared labels (idents) }
		     proc:     idp;   { ident of currently compiled proc/func }
		     LexLev:   natural; { Lexical level of compiled proc/func }
		     MarkHeap: pointer; 	{    }
		     saveDS:   natural);		      { save of dsize }
					 { ------- Level  UNIT ------- }
	   UnitLvl: (DBLids:   idp;		     { Duplicated identifiers }
		     ExpTypes: idp;			     { Exported types }
		     Ver,					   { Version, }
		     Date,					     { date & }
		     Time:     Cardinal;		{ time of compilation }
		     UnitNo:   integer);
		       { ------- Level    record ------- }
	   Crec,				     { const Parameter record }
	   Vrec:  (Vaddr: natural);		       { Var Parameter record }

	   Drec:  (Clev, Caddr: natural);     { Normal (Direct access) record }

	   Xrec,					    { eXternal record }
	   XCrec: (Xseg, Xaddr: natural);	   { eXternal ReadOnly record }

       end { LevelRecord };

       Attribute = record
	 t: typep;
	 amin,		  {         scalar.   }
	 amax:	 LongInt;	   {        }
	 access: Vaccess;	    {     case  VRBL  }
	 case kind: AttrKind of
	   Cnst: (Aval: Value);
	   Vrbl: (Aaddr: natural;
		  case VAccess of
		      direct: (Alvl:   natural);		  { lex level }
		     xternal: (ASegNo: natural);		 { segment No }
		    indirect: (AIOffs: natural);	   { offset in record }
		    SBaccess,
		    UBaccess: (Abytes: natural);   { number of bytes accessed }
		 );
	   Expr: ();
       end { Attribute };

{-----------------------------------------------------------------------------}

		 { Most used global variables for syntax & semantic analisys. }
  var sy:		symbol; 		       { Last symbol (token) -}
      ga:		attribute;			 { global attributes -}
      LexLevel: 	shortcard;		     { Current Lexical level *}
      level, levelx:	levelp; 		  { Current & Id found level *}
      LastLevel:	levelp; 		      { Last proc/func level *}

      ipc:		integer;
      dsize, MaxDSize:	natural;

      ProcNo,					      { Current Procedure No *}
      SegNo,						{ Current segment No *}
      NextProc, 				       { Next unused Proc No *}
      NextSeg:		natural;		    { Next unused segment No *}

							    { Standard types: }
      int_t,  lint_t, sint_t,			{ integer, LongInt, ShortInt *}
      card_t, scrd_t, ntrl_t,		      { cardinal, ShortCard, natural *}
      wrd_t,  lwrd_t, byte_t: typep;		      { word, LongWord, byte *}
      real_t, AnyType:	      typep;			     { real, untyped *}
      txt_t,  file_t:	      typep;				{ text, file *}
      char_t, str_t, Mstr_t,			 { char, string, string[255] *}
      bool_t, ptr_t:	      typep;			  { boolean, pointer *}
      ExportTypes:	      idp;	{ Exported types (linked in a queue) *}

      Units:		idp;	 { First imported unit (Standard) from queue *}
      Nunits:		shortcard;			   {    *}
      SvQualUnit:	idp;	     {    procedure QualIdent -}

				     { Global variables for Lexical analisys: }
      ErrLevel: 	ShortCard;	     { Error Level, 0..7 (exit code) *}
      ErrSy:		symbol; 		 {     *}
      Errors,						    { Errors Counter *}
      Warnings, 					  { Warnings Counter *}
      LineCnt,			      { Line Counter in current include file *}
      LLineCnt, 		       { Save of LineCnt for error reporting *}
      TotalLines:	cardinal;  { Total line counter (all compiled files) *}
      TotalCode:	LongInt;	   { Total code size. (All segments) *}
      Fposition,				   { Position in Source file *}
      Lposition,		    { Position of last symbol in source file *}
      Eposition:	LongInt;	   { Position of last reported error *}
      Ilevel:		shortcard;	       { Include files nesting level *}
      CondLevel,		     { Conditional compilation nesting level *}
      TrueLevel:	cardinal;	  { number of true conditional level *}
      nm:		string[8];		   { name of last identifier -}
      TempStart:	LongInt;   { start pos in temporary file for cur seg *}
      TempItems:	natural;   {      cur seg *}
      CodeSize, 			      { code size of current segment *}
      CpoolSz,						{ Constant pool size *}
      RelctSz:		natural;		      { Relocation info size *}

      Ifile:		array [0..MaxIncl] of record			    {*}
	F:	^file; { file fields not allowed in UniPascal,so use pointer *}
	Fpos:	LongInt;			     { Save of file position *}
	Lcount: cardinal;			      { Save of line counter *}
	Clevel: cardinal;		       { Save of Conditional nesting *}
        fname:  string[ShowNameSz];             {      show *}
      end { IncludeFiles };

      Last: record
	I:   LongInt;				     { Last Integer constant -}
	R:   Real;					{ Last Real constant -}
	S:   StringP;				      { Last string constant -}
	St:  ByteSet;					 { Last set constant -}
      end { Last };

      BlckBegSys, SelectSys, FacBegSys, { Stop, Start symbols and other sets. }
      TypeBegSys, TypeDels,  StatFolSys,
      StatBegSys, SimpTypeBegSys,
      AddOps, MulOps, RelOps:	syset;
							    { Compiler falgs: }
      test,					     { work boolean variable -}
      MakeDbl,				   { force convertion to double word -}
      InInit,				{ Compiler Initialization in process *}
      InDecl,					    { Compiling declarations *}
      EOFfound, 				     { EOF found in SkipLine *}
      SkipSource,		 { Skip-   conditional compilation *}
      PrtErr,				     {        *}
      Undefined,	      { Identifier not found (SearchId or QualIdent) -}
      InPrgrm,		     { Compiling program body or unit implementation *}
      IntfcOnlyU,			      { Unit coud be Interfeace only *}
      InLink,					     { Linking with OBJ file *}
      InComment:  boolean;		      { Skip-    *}
      ErrorWait:  boolean;                                 { Wait after error }

							   { Compiler Options }
      SwitchOps: set of 0..25;		 {    +/-  (26 ) *}

      Opt: packed record case boolean of
	false: (All: packed array ['A'..'Z'] of boolean);
	true:  (A,
		B,
		C, D, E, F, G, H,
		IOchk,						  { I/O check }
		J, K, L,
		ModulaLike,			    { Modula Like compilation }
		NameChk,			       { proc/func Name check }
		O,
		AutoPack,		{ automaticly pack all packable types }
		Quiet,			       { Quiet compilation (no bells) }
		Rchk,						{ Range check }
		S, T,
		UnitChk,			  { CheckUnits for initialize }
		V,
		Warning,			       { Turn on/off warnings }
		X,
		YGP,				 { My Conditional compilation }
		Z: boolean);
      end { Opt };

				 { Structure and variable for Lexical Analyst }
  const Class_D  = #$01;			       { separators (skipped) }
	Class_C  = #$02;				   { special keywords }
	Class_E  = #$04;				      { user handling }
	Class_A  = #$08;				{ Class A identifiers }
	Class_B  = #$10;				{ Class B identifiers }
	Class_A1 = #$20;			      { Class A' (A continue) }
	Class_B1 = #$40;			      { Class B' (B continue) }
	Class_C1 = #$80;			      { Class C' (C continue) }

  type token = (InvalidCh,		{ Ch-   (Classes[ch] = 0) }
		UserCh, 	 { Ch-     (User handler) }
		EndBuff,			     { Source buffer is empty }
		IdentA, 			      { Identifier of class A }
		IdentB, 			      { Identifier of class B }
		Akeyword,				 { KeyWord of class A }
		Bkeyword,				 { KeyWord of class B }
		Ckeyword);				 { KeyWord of class C }

       LexStructure = packed record	     {     }
	 IdName:    StringP;				 { pointer to string *}
	 IdSize:    ShortCard;	      {     *}
	 flags:     byte;			   {     *}
	 buffer:    pointer;			      { ptr to source buffer *}
	 buffsz,					{    *}
	 index, 					    { index   *}
	 start:     natural;	    {     identifier (if any) -}
	 KeyWordNo: natural;	   { Number of KeyWord (0 if not a key word) -}
	 Classes:   pointer;		      { ptr to byte array of classes *}
	 ClassAkw,			       { ptr to key words of class A *}
	 ClassBkw,			       { ptr to key words of class B *}
	 ClassCkw:  pointer;		       { ptr to key words of class C *}
       end { LexStructure };

  var LexS:    LexStructure;
      CondKW:  pointer;       { Class A keywords for conditional compilation *}
      defined: string[maxdef];		  {   conditional compilation *}

      ErrorSy:	  packed array [symbol] of ShortCard;	   { Expected Errors *}
					    {$ifNdef Q}
      Undeclared: array [Classes] of idp;      {$endif} { for error recovary *}

      SerialNo:   LongWord;			  { Compiler's serial number *}
      TempName:   StringP;		     { ptr to name of Temporary file *}
      UsesPaths:  StringP;  { ptr to paths for symbol tables of a used units *}
      INCpaths:   StringP;			       { include files paths *}
      OBJpaths:   StringP;				{ object files paths *}
      LibName:	  StringP;				      { Library Name *}
      SYMname:	  StringP;				     { SYM file name *}
      BDYname:	  StringP;				     { BDY file name *}
      PGMname:	  StringP;				     { PGM file name *}
      CURname:	  StringP;				 { Current file name *}

      CodeFile:   file; 		    { code file (.pgm, .sym or .bdy) *}
      TempFile:   file; 				    { temporary file *}

					{ Other Variables. (buffers, etc... ) }
      ProcBuff:     packed array [0..MaxCodeSz-1] of byte;     { Code buffer -}
      TxtBuffer:    packed array [0..TxtBuffSz-1] of char;   { Source buffer -}
      Cver,							  { VERSION, *}
      Cdate,							    { DATE & *}
      Ctime:	    cardinal;			       { TIME of compilation *}
      Compilation:  symbol;	{ unit, interface, implementation or program *}
      DefaultFiles: word;		   { $XXYY - XX infile, YY - outfile *}
      ElseIfPos:    shortcard;	{      elsif  KeyWords *}

      OKcode:	    cardinal;			  {       *}
      LastPara:     cardinal;	 { para No of info for last compiled segment *}
      SegStart:     cardinal;	      { block No for segment start (current) *}
      prognm:	    string[8];		 { program/unit name (for file name) *}

  type TmpDesc = (_const_, _relinfo_, _procoffs_, _constpool_);

       TmpSaveInfo = packed record    { save inforamtion for previous segment }
	 CdePos,
	 TmpPos,
	 TmpStrt: Longint;
	 TmpItms: natural;
	 CurProc,
	 ProcNxt: shortcard;
	 SegStrt: cardinal;
	 CdSize,
	 CpSize,
	 RlctSz:  natural;
       end { TmpSaveInfo };

  var UserBreak: boolean;	   {         Ctrl-C }

  type SYMheader = packed record
	 ID:	packed array [0..9] of char;
	 vmaj,
	 vmin:	byte;
	 serNo: LongWord;
       end { SYMheader };


{  '*'          ,  '-' }
{       ,         }
{      .        init }
{-----------------------------------------------------------------------------}